import os
import ebooklib
from ebooklib import epub
from bs4 import BeautifulSoup
import html2text


def extract_text_from_epub(epub_path, txt_path):
    # Open the EPUB file
    book = epub.read_epub(epub_path)

    # Create or open the output text file in write mode
    with open(txt_path, 'w', encoding='utf-8') as txt_file:
        # Iterate over all the HTML content in the EPUB and extract the text
        for item in book.get_items():
            if item.get_type() == ebooklib.ITEM_DOCUMENT:
                # Extract the HTML content
                html_content = item.get_content()

                # Convert HTML to plain text
                soup = BeautifulSoup(html_content, 'html.parser')
                text = html2text.html2text(str(soup))

                # Write the text to the text file
                txt_file.write(text)
                txt_file.write('\n')


# Source directory containing EPUB files
source_directory = r'E:\Dojo\Internship\week 4\streamlit_init\content\download_eng'

# Destination directory to store TXT files
destination_directory = r'E:\Dojo\Internship\week 4\streamlit_init\content\txt_data'

# Iterate over all files in the source directory
for filename in os.listdir(source_directory):
    if filename.endswith('.epub'):
        # Construct the paths for the EPUB and TXT files
        epub_path = os.path.join(source_directory, filename)
        txt_filename = os.path.splitext(filename)[0] + '.txt'
        txt_path = os.path.join(destination_directory, txt_filename)

        # Extract text from EPUB and store it in a text file
        extract_text_from_epub(epub_path, txt_path)

        print(f"Text extraction completed. Output saved to: {txt_path}")